// • ▌ ▄ ·.  ▄▄▄·  ▄▄ • ▪   ▄▄· ▄▄▄▄·  ▄▄▄·  ▐▄▄▄  ▄▄▄ .
// ·██ ▐███▪▐█ ▀█ ▐█ ▀ ▪██ ▐█ ▌▪▐█ ▀█▪▐█ ▀█ •█▌ ▐█▐▌·
// ▐█ ▌▐▌▐█·▄█▀▀█ ▄█ ▀█▄▐█·██ ▄▄▐█▀▀█▄▄█▀▀█ ▐█▐ ▐▌▐▀▀▀
// ██ ██▌▐█▌▐█ ▪▐▌▐█▄▪▐█▐█▌▐███▌██▄▪▐█▐█ ▪▐▌██▐ █▌▐█▄▄▌
// ▀▀  █▪▀▀▀ ▀  ▀ ·▀▀▀▀ ▀▀▀·▀▀▀ ·▀▀▀▀  ▀  ▀ ▀▀  █▪ ▀▀▀
//      Magicbane Emulator Project © 2013 - 2022
//                www.magicbane.com


package engine.devcmd.cmds;

import engine.CollisionEngine.Mesh;
import engine.Enum;
import engine.devcmd.AbstractDevCmd;
import engine.objects.*;

public class ColliderCmd extends AbstractDevCmd {

    public ColliderCmd() {
        super("collider");
    }

    @Override
    protected void _doCmd(PlayerCharacter pc, String[] words,
                          AbstractGameObject target) {

        String newline = "\r\n ";
        String output;
        if(target.getObjectType().equals(Enum.GameObjectType.Building) == false){
            throwbackInfo(pc,"Please Select A Building To Show Collider Data");
        }
        Building building = (Building)target;
        output = "Collision Info:" + newline;
        output += "Total Meshes: " + building.buildingMeshes.size() + newline;
        for(Mesh mesh : building.buildingMeshes){
            output += "-----------------------------" + newline;
            output += "Mesh ID: " + mesh.mesh_id + newline;
            output += "Mesh Location: " + mesh.mesh_location + newline;
            output += "Mesh Scale: " + mesh.mesh_scale + newline;
            output += "Mesh Min/Max: " + mesh.mesh_min_y + "/" + mesh.mesh_max_y + newline;
            output += "Mesh Triangle Count: " + mesh.triangles.size() + newline;
            output += "Mesh Rect: " + mesh.mesh_bounds + newline;
            output += "-----------------------------" + newline;
        }

        throwbackInfo(pc,output);
    }

    @Override
    protected String _getHelpString() {
        return "Displays Information About Colliders";
    }

    @Override
    protected String _getUsageString() {
        return "' /collider displays collision info when selected on a building";

    }

}
